#pragma once
#include <vector>
#include "Graphics.h"
#include "Rect.h"
#include "Surface.h"
#include "Vec2.h"

class Animation
{
public:
	Animation(int x, int y, const Surface& surface,
		int frameWidth, int frameHeight, 
		int totalFrame, int stopFrame, int playframe,
		float interval, Color chromaKey = Colors::Magenta);

	Animation(const Vei2& position, const Surface& surface, 
		int frameWidth, int frameHeight, 
		int totalFrame, int stopFrame, int playframe,
		float interval, Color chromaKey = Colors::Magenta);
	
	void Draw(const Vei2& position, Graphics& gfx) const;
	void Draw(const Vei2& position, Graphics& gfx, const RectI& clip) const;
	void Draw(const Vei2& position, Graphics& gfx, Color substituteColor) const;
	void Update(float dt);
	bool isStopped();
	void Stop();
	void Play();
private:
	void Next();

private:
	const Surface& surface;
	const Color chromaKey;
	std::vector<RectI> frames;
	int currentFrame = 0;
	int stopFrame = 0;
	int playFrame = 1;
	float interval = 0.0f;
	float totalTime = 0.0f;
};