#pragma once
#include "../Vec2.h"
#include "../Animation.h"
#include "../Effect.h"

class Link
{
public:
	Link(const Vec2& in_position);
	void SetDirection(const Vec2& in_velocity);
	void Update(float dt);
	Effect& GetEffect();
	void Draw(Graphics& gfx) const;
	void Draw(Graphics& gfx, Color substituteColor) const;
private:
	bool IsStop();
private:
	Surface surface = Surface("Images\\link90x90.bmp");
	const int frameWidth = 90;
	const int frameHeight = 90;
	const int stopFrame = 0;
	const int playFrame = 1;
	const int totalFrame = 5;
	const float interval = 0.16f;
	const Color chromaKey = Colors::Magenta;
	Vec2 position;
	Vec2 velocity = {0.0f, 0.0f};
	std::vector<Animation> animations;
	Effect damage = Effect(0.035f);

	enum Sequences
	{
		Left, Right, Up, Down, Count
	};
	Sequences currentDirection = Right;
	float speed = 5.0f;

};
