#pragma once
#include "Graphics.h"
#include "Surface.h"
#include "Vec2.h"

class Font
{
public:
	Font(const std::string& fileName, Color chromaKey = Colors::White);
	void DrawText(const std::string& text, Color substituteColor,
		const Vei2 position, Graphics& gfx) const;

private:
	RectI GetGlyph(char c) const;
private:
	Surface surface;
	int glyphWidth;
	int glyphHeight;

	//number of columns / rows in the font sheet
	static constexpr int numOfColumns = 32;
	static constexpr int numOfRows = 3;

	Color chromaKey;

	static constexpr char firstChar = ' ';
	static constexpr char lastChar = '~';
};