#pragma once
#include "Colors.h"
#include <memory>
#include <string>
#include "Rect.h"
#include <vector>

class Surface
{
public:
	Surface(const std::string& filename);
	Surface(int width, int height);
	Surface(const Surface& rhs) = default;
	Surface(Surface&& donor);
	Surface& operator=(const Surface& rhs) = default;
	Surface& operator=(Surface&& rhs);
	Surface() = default;
	void PutPixel(int x, int y, Color c);
	Color GetPixel(int x, int y) const;
	int GetWidth() const;
	int GetHeight() const;
	RectI GetRect() const;
	void Fill(Color c);
	const Color* Data() const;
private:
	int width = 0;
	int height = 0;
	std::vector<Color> pixels;
};